     /////////////////////////////////////////
    // THE CONSTRAINT-UNDERSTANDING SYSTEM ///
   // Written by Andrew Broad             ////
  //                                     /////
 // EnumSymbol.java (1998:10:27 11:10)  //////
/////////////////////////////////////////////
// Methods of EnumSymbol:              /////
// - EnumSymbol constructor            ////
// - equals                            ///
// - toString                          //
////////////////////////////////////////

import java.io.*;

/*******************************************************************************
** The class `EnumSymbol' represents an enumeration symbol.
*******************************************************************************/

public class EnumSymbol implements Serializable {
	private String _symbol;

	/**********************************************************************/
	// EnumSymbol constructor : String ->
	/***********************************************************************
	** Constructs an instance of EnumSymbol.
	** @param symbol A string representing the enumeration symbol.
	***********************************************************************/

	public EnumSymbol (String symbol) {
		_symbol= symbol;
	}

	/**********************************************************************/
	// EnumSymbol.equals : Object -> boolean
	/***********************************************************************
	** Returns true just in case the given object is an EnumSymbol whose
	** string is equal to this one.
	** @param anObject The Object to be compared.
	** @returns True just in case the given object is an EnumSymbol whose
	** string is equal to this one.
	***********************************************************************/

	public boolean equals (Object anObject) {
		return (anObject instanceof EnumSymbol
		       && _symbol.equals(((EnumSymbol)anObject).toString()));
	}

	/**********************************************************************/
	// EnumSymbol.toString : void -> String
	/***********************************************************************
	** Returns the string representation of this enumeration symbol.
	** @param anObject The string representation of this enumeration symbol.
	***********************************************************************/

	public String toString () {
		return _symbol;
	}
}